<%   
'    TrackBack Classes for BlogWorks XML 1.1.0
'    Copyright  2002-2003  Paul Schaeflein & Adrian Frost

'   This program is free software; you can redistribute it and/or modify
'   it under the terms of the GNU General Public License as published by
'   the Free Software Foundation; either version 2 of the License, or
'   (at your option) any later version.
'
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'   blogworks@xasperate.com



%>
<%
'
'
'   Original ASP Classes design courtesy of Paul Schaeflein
'
'
'   This program is free software; you can redistribute it and/or modify
'   it under the terms of the GNU General Public License as published by
'   the Free Software Foundation; either version 2 of the License, or
'   (at your option) any later version.
'
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'   blogworks@xasperate.com

Class clsTrackBack
	Dim m_PostID,m_Admin_URL,m_Writable_URL,m_TB
	
	Public Property Let PostID(id)
		m_PostID = id
	End Property

	Public Property Let AdminURL(url)
		m_Admin_URL = cleanURL(url)
	End Property

	Public Property Let WritableURL(url)
		m_Writable_URL = cleanURL(url)
	End Property

	Public Property Get Postid()
		postid = m_PostID
	End Property

	Public Property Get URL()
		URL = m_Admin_URL & "incoming.asp?id=" & m_PostID
	End Property

	Private Property Get MappedAdminDir()
		dir = urlTodir(m_Admin_URL)
		MappedAdminDir = Server.Mappath(dir) & "\"
	End Property

	Private Property Get MappedIncomingDir()
		dir = urlTodir(m_Writable_URL)
		dir = dir & "incoming"
		MappedIncomingDir = Server.Mappath(dir) & "\"
	End Property

	Private Function cleanURL(url)
		If right(url,1) <> "/" Then
			url = url & "/"
		End If
		
		cleanURL = url
	End Function

	Private Function urlTodir(url)
		server_name = request.servervariables("SERVER_NAME")
		server_name = "http://" & server_name

		url = cleanURL(url)

		dir = right(url,len(url)-len(server_name))
		urlTodir = dir
	End Function

	Public Sub Initialize()
		' Load the received TrackBacks into memory
		Set m_TB = Server.CreateObject("Microsoft.XMLDOM")
		m_TB.setProperty "SelectionLanguage","XPath" 
		m_TB.load MappedIncomingDir & "rx" & PostID & ".xml"
	End Sub

	Public Sub Terminate()
		Set m_TB = nothing
	End Sub

	Public Property Get Pings()
		Dim oPings
		
		' Get the Pings collection
		Dim sXPath
		sXPath = "//item"
		Set m_Pings = m_TB.selectNodes(sXPath)

		Set oPings = New ClsTBpings
		oPings.Initialize(m_Pings)
		Set Pings = oPings
	End Property

	Public Property Get Count()
		Dim oPings
		
		' Get the Pings collection
		Dim sXPath
		sXPath = "//item"
		Set m_Pings = m_TB.selectNodes(sXPath)
		Count = m_Pings.length
	End Property

End Class

Class ClsTBpings
	Private m_Pings
	
	Public Sub Initialize(oNodeList)
		Set m_Pings = oNodeList
	End Sub
	
	Public Property Get Length
		Length = m_Pings.Length 
	End Property

	Public Property Get Item(index)
		Dim oPing
		Set oPing = New clsTBping

		' First, pass the correct node to the class
		oPing.Initialize m_Pings.item(index)
				
		' Then, send the class to the caller
		Set Item = oPing
	End Property
End Class


Class clsTBping
	Dim m_Ping

	Public Sub Initialize(oNode)
		Set m_Ping = oNode
	End Sub

	Public Property Get time()
		time = m_Ping.selectSingleNode("pubDate").text
	End Property
	
	Public Property Get url()
		url = m_Ping.selectSingleNode("link").text
	End Property

	Public Property Get title()
		title = m_Ping.selectSingleNode("title").text
	End Property

	Public Property Get blogname()
		blogname = m_Ping.selectSingleNode("source").text
	End Property

	Public Property Get excerpt()
		excerpt = m_Ping.selectSingleNode("description").text
	End Property

End Class
%>