<%
'    Adrian Frost - BlogWorks XML 1.1.0
'    Copyright  2002-2003  Adrian Frost
'
'   This program is free software; you can redistribute it and/or modify
'   it under the terms of the GNU General Public License as published by
'   the Free Software Foundation; either version 2 of the License, or
'   (at your option) any later version.
'
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'   blogworks@xasperate.com



%>

<%
' ****************************************
' 
' Backup XML files before any operations!
' this sub keeps a rolling list of last five changes.
'
' ****************************************

Public Sub BackupXML(fileName,originalPath)
backupFile = left(fileName,len(fileName)-4)
Set fso = CreateObject("Scripting.FileSystemObject")
If fso.fileExists(server.mappath(writable_dir & "backup/" & backupFile & ".bk4")) Then
	' copy to bk 5
	fso.CopyFile (server.mappath(writable_dir & "backup/" & backupFile & ".bk4")), (server.mappath(writable_dir & "backup/" & backupFile & ".bk5")), true
End If

If fso.fileExists(server.mappath(writable_dir & "backup/" & backupFile & ".bk3")) Then
	' copy to bk 4
	fso.CopyFile (server.mappath(writable_dir & "backup/" & backupFile & ".bk3")), (server.mappath(writable_dir & "backup/" & backupFile & ".bk4")), true
End If

If fso.fileExists(server.mappath(writable_dir & "backup/" & backupFile & ".bk2")) Then
	' copy to bk 3
	fso.CopyFile (server.mappath(writable_dir & "backup/" & backupFile & ".bk2")), (server.mappath(writable_dir & "backup/" & backupFile & ".bk3")), true
End If

If fso.fileExists(server.mappath(writable_dir & "backup/" & backupFile & ".bk1")) Then
	' copy to bk 2
	fso.CopyFile (server.mappath(writable_dir & "backup/" & backupFile & ".bk1")), (server.mappath(writable_dir & "backup/" & backupFile & ".bk2")), true
End If

'copy curent XML to bk1
fso.CopyFile (server.mappath(originalPath & backupFile & ".xml")), (server.mappath(writable_dir & "backup/" & backupFile & ".bk1")), true
End Sub



' ****************************************
' 
' Create Blog File sub
'
' ****************************************

Public Sub CreateBlog(targetFile)
Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM") 
Set procBlog = objXMLDoc.createProcessingInstruction("xml","version=""1.0"" encoding=""" & encode_as & """")
objXMLDoc.appendChild(procBlog)

Set rootBlog = objXMLDoc.createElement("baef")
objXMLDoc.appendChild(rootBlog)

Set objAttr = objXMLDoc.createAttribute("version") 
Set xmlRoot = objXMLDoc.documentElement

xmlRoot.setAttribute "version", "1.0" 

Set fs = Server.CreateObject("Scripting.FileSystemObject")

If fs.FolderExists(server.mappath(writable_dir)) = True Then
	objXMLDoc.save(server.mappath(writable_dir & targetFile))
Else
	GeneralError = "cb_xml1"
	Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub



' ****************************************
' 
' Blog Append Post sub
'
' ****************************************

Public Sub AppendBlog(targetFile)

BackupXML targetFile,writable_dir

Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))
Set ParseErr = objXMLDoc.parseError 

If ParseErr.errorCode <> 0 Then 
	GeneralError = "ab_xml2"  'Couldn't parse document
	Exit Sub
End If

Set xmlRoot = objXMLDoc.documentElement
Set objNewBlog = objXMLDoc.createElement("blog")
objNewBlog.setAttribute "id", postID 
xmlRoot.InsertBefore objNewBlog,xmlRoot.firstChild

'Author Element
Set objNewAuthor = objXMLDoc.createElement("author")
objNewBlog.appendChild(objNewAuthor)

Set objAuthorName = objXMLDoc.createElement("authorname")
objAuthorName.text = postAuthorName
objNewAuthor.appendChild(objAuthorName)

Set objAuthorMail = objXMLDoc.createElement("authormail")
objAuthorMail.text = postAuthorMail
objNewAuthor.appendChild(objAuthorMail)

'Information Element
Set objNewInfo = objXMLDoc.CreateElement("information")
objNewBlog.appendChild(objNewInfo)

Set objInfoComment = objXMLDoc.createElement("commentthread")
objInfoComment.text = postCommentID
objNewInfo.appendChild(objInfoComment)

Set objInfoStamp = objXMLDoc.createElement("timestamp")
objInfoStamp.text = postTime
objNewInfo.appendChild(objInfoStamp)

Set objInfoLang = objXMLDoc.createElement("language")
objInfoLang.text = blog_lang
objNewInfo.appendChild(objInfoLang)

Set objInfoCats = objXMLDoc.createElement("categories")
objNewInfo.appendChild(objInfoCats)

Set objInfoCat = objXMLDoc.createElement("category")
objInfoCat.setAttribute "id", postCatID 
objInfoCat.text = postCatName
objInfoCats.appendChild(objInfoCat)

'Text Element
Set objNewText = objXMLDoc.CreateElement("text")
objNewBlog.appendChild(objNewText)

Set objTextTitle = objXMLDoc.createElement("blogtitle")
Set objTextTitleCD = objXMLDoc.createCDATASection(postTitle)
objTextTitle.appendChild(objTextTitleCD)
objNewText.appendChild(objTextTitle)

Set objTextBody = objXMLDoc.createElement("blogbody")
Set objTextBodyCD = objXMLDoc.createCDATASection(postBody)
objTextBody.appendChild(objTextBodyCD)
objNewText.appendchild(objTextBody)

Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir)) = True Then
	objXMLDoc.save(server.mappath(writable_dir & targetFile))
Else
	GeneralError = "ab_xml3"   'Can't save appended data
	Set objXMLDoc = nothing
	Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub



' ****************************************
' 
' Blog Delete Post Sub
'
' ****************************************

Public Sub DelPost(targetfile,postid)
BackupXML targetFile,writable_dir
Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
	GeneralError = "dp_xml2" 'Couldn't parse document
	Exit Sub
End If
Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
For i = 0 to n_blogs-1
If blogs.item(i).getAttribute("id") = postid Then
	nodeToRemove = i
End If
Next
Set objExNode = xmlRoot.removeChild(xmlRoot.childNodes.item(nodeToRemove)) 
Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir)) = True Then
	If n_blogs = 1 Then
		fs.DeleteFile server.mappath(writable_dir & targetFile), true
	Else
		objXMLDoc.save(server.mappath(writable_dir & targetFile))
	End If
Else
	GeneralError = "xml4"   'Can't save edited data
	Set objXMLDoc = nothing
	Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Blog Save Edited Post sub
'
' ****************************************

'Sub that will replace the chosen node with a new node.
Public Sub SaveEditedPost(targetfile,postid)
BackupXML targetFile,writable_dir
Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
	GeneralError = "sep_xml2" 'Couldn't parse document
	Exit Sub
End If

Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length

For i = 0 to n_blogs-1
	If blogs.item(i).getAttribute("id") = postid Then
		nodeToReplace = i
	End If
Next

'Create document fragment from the new title/body info then replace the text element with the new fragment.
Set xmlFragment = objXMLDoc.createDocumentFragment()
'Text Element
Set objNewText = objXMLDoc.CreateElement("text")
xmlFragment.appendChild(objNewText)

Set objTextTitle = objXMLDoc.createElement("blogtitle")
Set objTextTitleCD = objXMLDoc.createCDATASection(postTitle)
objTextTitle.appendChild(objTextTitleCD)
objNewText.appendChild(objTextTitle)

Set objTextBody = objXMLDoc.createElement("blogbody")
Set objTextBodyCD = objXMLDoc.createCDATASection(postBody)
objTextBody.appendChild(objTextBodyCD)
objNewText.appendchild(objTextBody)

Set objExch = xmlRoot.childNodes(nodeToReplace).replaceChild(xmlFragment,xmlRoot.childNodes(nodeToReplace).childNodes(2))
Set fs = Server.CreateObject("Scripting.FileSystemObject")

If fs.FolderExists(server.mappath(writable_dir)) = True Then
	objXMLDoc.save(server.mappath(writable_dir & targetFile))
Else
	GeneralError = "xml4"   'Can't save edited data
	Set objXMLDoc = nothing
	Exit Sub
End If

set fs = nothing
Set objXMLDoc = nothing
End Sub



' ****************************************
' 
' Blog Get a single post sub
'
' ****************************************

Public Function GetSinglePost(targetFile,postid_int)
Dim output_array(7)
If postid_int = "" Then
	postid_int = "0"
End If

Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))


Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length

For i = 0 to n_blogs-1
	If blogs.item(i).getAttribute("id") = postid_int Then
		nodeToRead = i
	End If
Next

postid = xmlRoot.childNodes(nodeToRead).getattribute("id")
authorname = xmlRoot.childNodes(nodeToRead).childNodes(0).childNodes(0).text
authormail = xmlRoot.childNodes(nodeToRead).childNodes(0).childNodes(1).text
commentthread = xmlRoot.childNodes(nodeToRead).childNodes(1).childNodes(0).text
timestamp = xmlRoot.childNodes(nodeToRead).childNodes(1).childNodes(1).text
language = xmlRoot.childNodes(nodeToRead).childNodes(1).childNodes(2).text
blog_title = xmlRoot.childNodes(nodeToRead).childNodes(2).childNodes(0).text
blog_body = xmlRoot.childNodes(nodeToRead).childNodes(2).childNodes(1).text

Set objXMLDoc = nothing

output_array(0) = postid
output_array(1) = authorname
output_array(2) = authormail
output_array(3) = commentthread
output_array(4) = timestamp
output_array(5) = language
output_array(6) = blog_title
output_array(7) = blog_body

GetSinglePost = output_array

End Function



' ****************************************
' 
' Blog Get Multiple Posts function
'
' ****************************************

'this function is the 'core' of blogworks along with the publishing engine.
'it will return a recordset of the desired posts. The normal mode will return
'Blogger API requirements (array of structs), the extended mode will return BW-XML ones.
'number_of_posts - the number of posts/days returned according to post_type
'ext - extended mode true/false. API - False, BW-XML - True
'linebreaks - whether to convert carriage reurns to linebreaks
'htmlencode - whether to convert HTML for sending over Blogger API
'bB - fix to work around blogBuddy's handling of carriage returns, not used internally
'mnth - return only current month's posts. For use in publishing engine



Function GetMultiplePosts(number_of_posts,ext,mnth,blogid)
'firstly, list all the xml files and sort them into reverse date order - i.e. newest first
set fs=Server.CreateObject("Scripting.FileSystemObject")

If fs.FolderExists(Server.MapPath(writable_dir)) = true Then
	set f=fs.GetFolder(Server.MapPath(writable_dir))
	set fo=f.files
	
		For each file in fo
			If right(file.name,14) = "archive" & blogid & ".xml" Then
				filestring = filestring & "#" & file.name
			End If
		Next

	set fo = nothing
	set f = nothing
	set fs = nothing
	
	If filestring = "" Then
		Exit Function
	End If
	
	filestring = right(filestring,len(filestring)-1)
	filestring = trim(filestring)
	filearray = split(filestring, "#")
	filestring = trim(filestring)

		'Bubblesort the array to find highest file number
		'The idea is to have a continuous index from the array which references the appropriate
		'file name/number - held in the array.

			for x = 0 to ubound(filearray) - 1
			    for y= 0 to ubound(filearray) - 1
			        if filearray(y)>filearray(y+1) then
			            temp=filearray(y+1)
			            filearray(y+1)=filearray(y)
			            filearray(y)=temp
			        end if
			    next
			next

	'create the receiving recordset
	'create fields based on whether weare reacting to Blogger API or not.
	
	Set Blogs = server.CreateObject("ADODB.RECORDSET") 
	Blogs.fields.append "userid",adVarChar,5
	
	If ext = false Then
		Blogs.fields.append "dateCreated",adDate
	Else
		Blogs.fields.append "dateCreated",adVarChar,120
	End If

	If ext = false Then
		Blogs.fields.append "content",adVarChar,256
	End If

	Blogs.fields.append "postid",adVarChar,15

	If ext = true Then
		Blogs.fields.append "authorname",adVarChar,100
		Blogs.fields.append "authormail",adVarChar,150
		Blogs.fields.append "commenthread",adVarChar,15
		Blogs.fields.append "language",adVarChar,2
		Blogs.fields.append "blogtitle",adVarChar,100
		Blogs.fields.append "blogbody",adVarChar,256
		Blogs.fields.append "timestamp",adVarChar,20
	End If
	Blogs.CursorLocation = adUseClient
	Blogs.CursorType = adOpenStatic
	Blogs.open

	'This is the fun bit
	'for each archive xml file open and then for each blog read it into the recordset
	'check the size of the recordset, if it equals the predetermined size from number_of_posts
	'then bomb out and return the recordset
	'If number_of_posts = "0" then all records are returned - so don't do it if you have a million and one blogs

	If mnth = true Then
		lowerRange = ubound(filearray)
	Else
		lowerRange = lbound(filearray)
	End If

	For j = ubound(filearray) to lowerRange step -1
		Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
		objXMLDoc.async = false 
		objXMLDoc.load(server.mappath(writable_dir & filearray(j)))

		Set xmlRoot = objXMLDoc.documentElement
		Set blogsxml = xmlRoot.getElementsByTagName("blog")

		n_blogs = blogsxml.length

		If n_blogs = 0 Then
			Exit Function
		End If


			For i = 0 to n_blogs-1
				postid = xmlRoot.childNodes(i).getattribute("id")
				authorname = xmlRoot.childNodes(i).childNodes(0).childNodes(0).text
				authormail = xmlRoot.childNodes(i).childNodes(0).childNodes(1).text
				commentthread = xmlRoot.childNodes(i).childNodes(1).childNodes(0).text
				timestamp = xmlRoot.childNodes(i).childNodes(1).childNodes(1).text
				language = xmlRoot.childNodes(i).childNodes(1).childNodes(2).text
				blog_title = xmlRoot.childNodes(i).childNodes(2).childNodes(0).text
				blog_body = xmlRoot.childNodes(i).childNodes(2).childNodes(1).text

				datetime = UnixToHuman(timestamp) 

				db_year = left(datetime,4)
				db_month = left(datetime,6)
				db_month = right(db_month,2)
				db_day = left(datetime,8)
				db_day = right(db_day,2)
				db_time = right(datetime,8)
				db_hour = left(db_time,2)
				db_minute = left(db_time,5)
				db_minute = right(db_minute,2)
				db_second = right(db_time,2)
				asp_date = dateserial(db_year,db_month,db_day) + timeserial(db_hour,db_minute,db_second)

				Blogs.addnew
				Blogs.fields("userid") = CInt(1)
		
				If ext = false Then
					Blogs.fields("dateCreated") = asp_date
				Else
					Blogs.fields("dateCreated") = datetime
				End If
			
				If ext = false Then
					If blog_title = "" Then
						Blogs.fields("content") = ":H:" & blog_body
					Else
						Blogs.fields("content") = blog_title & ":H:" & blog_body 
					End If
				End If
		
				Blogs.fields("postid") = postid
				
				If ext = true Then
					Blogs.fields("authorname") = authorname
					Blogs.fields("authormail") = authormail
					Blogs.fields("commenthread") = commentthread
					Blogs.fields("language") = language
					Blogs.fields("blogtitle") = blog_title
					Blogs.fields("blogbody") = blog_body
					Blogs.fields("timestamp") = timestamp
				End If

				If Blogs.RecordCount = CInt(number_of_posts) Then
					StopThing = true
					Exit For
			
				End If
			Next


			If StopThing = true Then
				Exit For
			End If
			Set objXMLDoc = nothing
	Next
	Blogs.movefirst
	Set GetMultiplePosts = Blogs
	Set Blogs = nothing
End If
End Function



' ****************************************
' 
' Blog - Get Months Post function
'
' ****************************************

Function GetMonthsPosts(file_name,ext,blogid)
'create the receiving recordset
'create fields based on whether weare reacting to Blogger API or not.
Set Blogs = server.CreateObject("ADODB.RECORDSET") 
Blogs.fields.append "userid",adVarChar,5
Blogs.fields.append "dateCreated",adVarChar,120

If ext = false Then
	Blogs.fields.append "content",adVarChar,256
End If

Blogs.fields.append "postid",adVarChar,15

If ext = true Then
	Blogs.fields.append "authorname",adVarChar,100
	Blogs.fields.append "authormail",adVarChar,150
	Blogs.fields.append "commenthread",adVarChar,15
	Blogs.fields.append "language",adVarChar,2
	Blogs.fields.append "blogtitle",adVarChar,100
	Blogs.fields.append "blogbody",adVarChar,256
End If

Blogs.CursorLocation = adUseClient
Blogs.CursorType = adOpenStatic
Blogs.open

'This is the fun bit

Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & file_name))

Set xmlRoot = objXMLDoc.documentElement
Set blogsxml = xmlRoot.getElementsByTagName("blog")
n_blogs = blogsxml.length

If n_blogs = 0 Then
	Exit Function
End If

If archive_order = "0" Then
strStart = 0
strFinish = n_blogs-1
strStep = 1
Else
strStart = n_blogs-1
strFinish = 0
strStep = -1
End If


For i = strStart to strFinish step strStep
	postid = xmlRoot.childNodes(i).getattribute("id")
	authorname = xmlRoot.childNodes(i).childNodes(0).childNodes(0).text
	authormail = xmlRoot.childNodes(i).childNodes(0).childNodes(1).text
	commentthread = xmlRoot.childNodes(i).childNodes(1).childNodes(0).text
	timestamp = xmlRoot.childNodes(i).childNodes(1).childNodes(1).text
	language = xmlRoot.childNodes(i).childNodes(1).childNodes(2).text
	blog_title = xmlRoot.childNodes(i).childNodes(2).childNodes(0).text
	blog_body = xmlRoot.childNodes(i).childNodes(2).childNodes(1).text

		datetime = UnixToHuman(timestamp) 

		Blogs.addnew
		Blogs.fields("userid") = "1"

		If ext = false Then
			' this needs to be an ASP date time to feed to the xml-rpc server...
			Blogs.fields("dateCreated") = "<dateTime.iso8601>" & datetime & "</dateTime.iso8601>"
		Else
			Blogs.fields("dateCreated") = datetime
		End If
	
		If ext = false Then
			If blog_title = "" Then
				Blogs.fields("content") = blog_body
			Else
				Blogs.fields("content") = blog_title & ":H:" & blog_body
			End If
		End If

		Blogs.fields("postid") = postid

		If ext = true Then
			Blogs.fields("authorname") = authorname
			Blogs.fields("authormail") = authormail
			Blogs.fields("commenthread") = commentthread
			Blogs.fields("language") = language
			Blogs.fields("blogtitle") = blog_title
			Blogs.fields("blogbody") = blog_body
		End If
	Set objXMLDoc = nothing
Next


Blogs.movefirst
Set GetMonthsPosts = Blogs
Set Blogs = nothing
End Function



' ****************************************
' 
' Config functions and subs
'
' ****************************************
' ****************************************
' 
' Config - Create Config file sub
'
' ****************************************

'Create the XML file to be filled.
Public Sub CreateConfig(targetFile)
Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM") 
Set procBlog = objXMLDoc.createProcessingInstruction("xml","version=""1.0""")
objXMLDoc.appendChild(procBlog)
Set rootBlog = objXMLDoc.createElement("blogconfig")
objXMLDoc.appendChild(rootBlog)
Set objAttr = objXMLDoc.createAttribute("version") 
Set xmlRoot = objXMLDoc.documentElement
xmlRoot.setAttribute "version", "1.1" 

Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & "data/")) = True Then
objXMLDoc.save(server.mappath(writable_dir & "data/" & targetFile))
Else
GeneralError = "1.1"
Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub



' ****************************************
' 
' Config - Check Config Version
'
' ****************************************
Public Function CheckConfigVersion(targetFile,blogid)
Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & "data/" & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
Exit Function
End If

Set xmlRoot = objXMLDoc.documentElement

config_ver = xmlRoot.getAttribute("version")
CheckConfigVersion = config_ver
Set objXMLDoc = nothing
End Function

' ****************************************
' 
' Config - Append new config
'
' ****************************************

'Add a new blog to the XML file
Public Sub AppendConfig(targetFile,blogid)

BackupXML "config.xml",writable_dir & "data/"

Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & "data/" & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
Exit Sub
End If

Set xmlRoot = objXMLDoc.documentElement


Set objNewBlog = objXMLDoc.createElement("blog")
objNewBlog.setAttribute "id", blogid 
xmlRoot.insertBefore objNewBlog, xmlRoot.lastChild 

Set objNewStandard = objXMLDoc.createElement("standard")
objNewBlog.appendChild(objNewStandard)

Set objNewName = objXMLDoc.createElement("name")
objNewName.text = blog_name
objNewStandard.appendChild(objNewName)

Set objNewDesc = objXMLDoc.createElement("description")
objNewDesc.text = blog_desc
objNewStandard.appendChild(objNewDesc)

Set objNewMainPage = objXMLDoc.createElement("mainpage")
objNewMainPage.text = blog_main_file
objNewStandard.appendChild(objNewMainPage)

Set objNewArchivePage = objXMLDoc.createElement("archivepage")
objNewArchivePage.text = archive_index_file
objNewStandard.appendChild(objNewArchivePage)

Set objNewRSSFile = objXMLDoc.createElement("rssfile")
objNewRSSFile.text = rss_file
objNewStandard.appendChild(objNewRSSFile)

Set objNewLang = objXMLDoc.createElement("language")
objNewLang.text = blog_lang
objNewStandard.appendChild(objNewLang)

Set objNewDateFormat = objXMLDoc.createElement("dateformat")
objNewDateFormat.text = date_format
objNewStandard.appendChild(objNewDateFormat)

Set objNewTimeFormat = objXMLDoc.createElement("timeformat")
objNewTimeFormat.text = time_format
objNewStandard.appendChild(objNewTimeFormat)

Set objNewTimeAdjust = objXMLDoc.createElement("timeadjust")
objNewTimeAdjust.text = time_adjust
objNewStandard.appendChild(objNewTimeAdjust)

Set objNewPerPage = objXMLDoc.createElement("perpage")
objNewPerPage.text = per_page
objNewStandard.appendChild(objNewPerPage)

Set objNewPing1 = objXMLDoc.createElement("ping1")
objNewPing1.text = ping1
objNewStandard.appendChild(objNewPing1)

Set objNewPing2 = objXMLDoc.createElement("ping2")
objNewPing2.text = ping2
objNewStandard.appendChild(objNewPing2)

Set objNewPing3 = objXMLDoc.createElement("ping3")
objNewPing3.text = ping3
objNewStandard.appendChild(objNewPing3)

Set objNewArchDate = objXMLDoc.createElement("archivedateformat")
objNewArchDate.text = archive_date_format
objNewStandard.appendChild(objNewArchDate)

Set objNewArchExt = objXMLDoc.createElement("archiveext")
objNewArchExt.text = archive_ext
objNewStandard.appendChild(objNewArchExt)

Set objNewTimeZone = objXMLDoc.createElement("timezone")
objNewTimeZone.text = time_zone
objNewStandard.appendChild(objNewTimeZone)

Set objNewArchiveOrder = objXMLDoc.createElement("archiveorder")
objNewArchiveOrder.text = archive_order
objNewStandard.appendChild(objNewArchiveOrder)

Set objNewPingBGS = objXMLDoc.createElement("pingBGS")
objNewPingBGS.text = ping_blo_gs
objNewStandard.appendChild(objNewPingBGS)

Set objNewPingBW = objXMLDoc.createElement("pingBlogWorks")
objNewPingBW.text = ping_bw
objNewStandard.appendChild(objNewPingBW)

Set objNewRSSVersion = objXMLDoc.createElement("rssversion")
objNewRSSVersion.text = rss_version
objNewStandard.appendChild(objNewRSSVersion)


Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & "data/")) = True Then
objXMLDoc.save(server.mappath(writable_dir & "data/" & targetFile))
Else
GeneralError = "1.3"   'Can't save appended data
Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Config - Delete config sub (not in use)
'
' ****************************************

Public Sub DeleteConfig(targetfile,blogid)

BackupXML "config.xml",writable_dir & "data/"

Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
Exit Sub
End If
Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
For i = 0 to n_blogs-1
If blogs.item(i).getAttribute("id") = postid Then
nodeToRemove = i
End If
Next
Set objExNode = xmlRoot.removeChild(xmlRoot.childNodes.item(nodeToRemove)) 
Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & "data/")) = True Then
objXMLDoc.save(server.mappath(writable_dir & "data/" & targetFile))
Else
GeneralError = "1.4"   'Can't save edited data
Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Config - Save Edited Config
'
' ****************************************

'Sub that will replace the chosen node with a new node.
Public Sub SaveEditedConfig(targetfile,blogid)

BackupXML "config.xml",writable_dir & "data/"

Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & "data/" & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
Exit Sub
End If
Set xmlRoot = objXMLDoc.documentElement


Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
For i = 0 to n_blogs-1
If blogs.item(i).getAttribute("id") = blogid Then
nodeToReplace = i
End If
Next
Set xmlFragment = objXMLDoc.createDocumentFragment()

Set objNewConfig = objXMLDoc.createElement("blog")
objNewConfig.setAttribute "id", blogid 
xmlFragment.appendChild(objNewConfig)

Set objNewBlog = objXMLDoc.createElement("standard")
objNewConfig.appendChild(objNewBlog)

Set objNewName = objXMLDoc.createElement("name")
objNewName.text = blog_name
objNewBlog.appendChild(objNewName)

Set objNewDesc = objXMLDoc.createElement("description")
objNewDesc.text = blog_desc
objNewBlog.appendChild(objNewDesc)

Set objNewMainPage = objXMLDoc.createElement("mainpage")
objNewMainPage.text = blog_main_file
objNewBlog.appendChild(objNewMainPage)

Set objNewArchivePage = objXMLDoc.createElement("archivepage")
objNewArchivePage.text = archive_index_file
objNewBlog.appendChild(objNewArchivePage)

Set objNewRSSFile = objXMLDoc.createElement("rssfile")
objNewRSSFile.text = rss_file
objNewBlog.appendChild(objNewRSSFile)

Set objNewLang = objXMLDoc.createElement("language")
objNewLang.text = blog_lang
objNewBlog.appendChild(objNewLang)

Set objNewDateFormat = objXMLDoc.createElement("dateformat")
objNewDateFormat.text = date_format
objNewBlog.appendChild(objNewDateFormat)

Set objNewTimeFormat = objXMLDoc.createElement("timeformat")
objNewTimeFormat.text = time_format
objNewBlog.appendChild(objNewTimeFormat)

Set objNewTimeAdjust = objXMLDoc.createElement("timeadjust")
objNewTimeAdjust.text = time_adjust
objNewBlog.appendChild(objNewTimeAdjust)

Set objNewPerPage = objXMLDoc.createElement("perpage")
objNewPerPage.text = per_page
objNewBlog.appendChild(objNewPerPage)

Set objNewPing1 = objXMLDoc.createElement("ping1")
objNewPing1.text = ping1
objNewBlog.appendChild(objNewPing1)

Set objNewPing2 = objXMLDoc.createElement("ping2")
objNewPing2.text = ping2
objNewBlog.appendChild(objNewPing2)

Set objNewPing3 = objXMLDoc.createElement("ping3")
objNewPing3.text = ping3
objNewBlog.appendChild(objNewPing3)

Set objNewArchDate = objXMLDoc.createElement("archivedateformat")
objNewArchDate.text = archive_date_format
objNewBlog.appendChild(objNewArchDate)

Set objNewArchExt = objXMLDoc.createElement("archiveext")
objNewArchExt.text = archive_ext
objNewBlog.appendChild(objNewArchExt)

Set objNewTimeZone = objXMLDoc.createElement("timezone")
objNewTimeZone.text = time_zone
objNewBlog.appendChild(objNewTimeZone)

Set objNewArchiveOrder = objXMLDoc.createElement("archiveorder")
objNewArchiveOrder.text = archive_order
objNewBlog.appendChild(objNewArchiveOrder)

Set objNewPingBGS = objXMLDoc.createElement("pingBGS")
objNewPingBGS.text = ping_blo_gs
objNewBlog.appendChild(objNewPingBGS)

Set objNewPingBW = objXMLDoc.createElement("pingBlogWorks")
objNewPingBW.text = ping_bw
objNewBlog.appendChild(objNewPingBW)

Set objNewRSSVersion = objXMLDoc.createElement("rssversion")
objNewRSSVersion.text = rss_version
objNewBlog.appendChild(objNewRSSVersion)


Set objExch = xmlRoot.replaceChild(xmlFragment,xmlRoot.childNodes(nodeToReplace))
Set objExch = nothing


Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & "data/")) = True Then
objXMLDoc.save(server.mappath(writable_dir & "data/" & targetFile))
Else
GeneralError = "1.4"   'Can't save edited data
Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Config - Cache Blog Listing
'
' ****************************************

Public Sub CacheBlogList(targetFile)
Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false
objXMLDoc.load(server.mappath(writable_dir & "data/" & targetFile))
Set xmlRoot = objXMLDoc.documentElement

Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
Session("bloglist_cnt") = n_blogs
For i = 0 to n_blogs-1
oblogid = xmlRoot.childNodes(i).getattribute("id")
If left(oblogid,2) = "00" Then
blogno = right(oblogid,1) & "."
ElseIf left(oblogid,1) = "0" Then
blogno = right(oblogid,2) & "."
End If

oblog_name = xmlRoot.childNodes(i).childNodes(0).childNodes(0).text
If blog_id = oblogid Then
optn = optn & "<option value=""" & oblogid & """ selected=""selected"">" & blogno & "&nbsp;" & left(oblog_name,14) & "</option>"
Else
optn = optn & "<option value=""" & oblogid & """>" & blogno & "&nbsp;" & left(oblog_name,14) & "</option>"
End If
Next
oblogid = ""
oblog_name =""
Session("bloglist") = optn
Session("bloglist_cnt") = n_blogs
End Sub


' ****************************************
' 
' Config - Count Configs
'
' ****************************************

Public Function CountConfigs(targetFile)
Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & "data/" & targetFile))
Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
CountConfigs = n_blogs
End Function


' ****************************************
' 
' Config - Read Config file
'
' ****************************************

Public Sub ReadConfig(targetFile,blogid)
' now that config files are checked and upgraded in one hit when v1.1 is run for the first time we don't need
' to worry about whether or not we're trying to read a 1.0 or 1.1 version config file.

If blogid = "" Then
blogid = "001"
End If
Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
objXMLDoc.async = false 
objXMLDoc.setProperty "SelectionLanguage","XPath" 
objXMLDoc.load(server.mappath(writable_dir & "data/" & targetFile))
Set xmlRoot = objXMLDoc.documentElement

sXPath = "//blog[@id='" & blogid & "']"

'Set mConfig = xmlRoot.selectNodes(sXPath)

blog_id = blogid
blog_name = xmlRoot.selectSingleNode(sXPath & "/standard/name").text
blog_desc = xmlRoot.selectSingleNode(sXPath & "/standard/description").text
blog_main_file = xmlRoot.selectSingleNode(sXPath & "/standard/mainpage").text
archive_index_file = xmlRoot.selectSingleNode(sXPath & "/standard/archivepage").text
rss_file = xmlRoot.selectSingleNode(sXPath & "/standard/rssfile").text
blog_lang = xmlRoot.selectSingleNode(sXPath & "/standard/language").text
date_format = xmlRoot.selectSingleNode(sXPath & "/standard/dateformat").text
time_format = xmlRoot.selectSingleNode(sXPath & "/standard/timeformat").text
time_adjust = xmlRoot.selectSingleNode(sXPath & "/standard/timeadjust").text
per_page = xmlRoot.selectSingleNode(sXPath & "/standard/perpage").text
ping1 = xmlRoot.selectSingleNode(sXPath & "/standard/ping1").text
ping2 = xmlRoot.selectSingleNode(sXPath & "/standard/ping2").text
ping3 = xmlRoot.selectSingleNode(sXPath & "/standard/ping3").text
archive_date_format = xmlRoot.selectSingleNode(sXPath & "/standard/archivedateformat").text
archive_ext = xmlRoot.selectSingleNode(sXPath & "/standard/archiveext").text
time_zone = xmlRoot.selectSingleNode(sXPath & "/standard/timezone").text
archive_order = xmlRoot.selectSingleNode(sXPath & "/standard/archiveorder").text
ping_blo_gs = xmlRoot.selectSingleNode(sXPath & "/standard/pingBGS").text
ping_bw = xmlRoot.selectSingleNode(sXPath & "/standard/pingBlogWorks").text
rss_version = xmlRoot.selectSingleNode(sXPath & "/standard/rssversion").text

Set objXMLDoc = nothing
End Sub
%>
